---
# If users_update_strategy is set to "all" then all users will be configured
# everytime the tasks in this role are run, it it is set to "changed" than only
# user accounts that have changes will be updated. If it is set to "apache" then
# present users with users_apache_virtual_hosts defined will have their Apache
# config updated. If it is set to "phpfpm" then present users in the phpfpm group
# will have their PHP-FPM pool config file updated. If it is set to "groups" and
# the users_update_groups array is defined then only users in these groups will
# be updated. If it is set to "check" then the users: YAML is checked only.
users_update_strategy: changed
# Define users_cusers_chroot hroot to true for members of the chroot group to be chrooted
users_chroot: false
# users_chroot_dir is the path to the rw chroot files
users_chroot_dir: "{{ chroot_dir | default('/chroot') }}"
# users_chroot_users_dir is the basedir for the chroot images to be mounted ro,
# one per user in the chroot group, for example /chroots/foo
users_chroot_users_dir: "{{ chroot_users_dir | default('/chroots') }}"
# Define users_apache to true for this role to manage the Apache VirtualHosts
users_apache: false
users_apache_chroot: "{{ apache_chroot | default(False) }}"
users_apache_chroot_suexec: false
users_apache_chroot_dir: "{{ apache_chroot_dir | default(users_chroot_users_dir + '/www-data') }}"
# users_apache_chroot_users_basedir is the directory that will be used to mount
# chrooted users home directories (it needs to be a sub-directory of /var/www for
# suEXEC
users_apache_chroot_users_basedir: /var/www/users
# Set users_apache_chroot_mount_dirs to the directories in /var/www that should be
# mounted read-only in the Apache chroot
users_apache_chroot_mount_dirs:
  - html
  - localhost
  - wsh
users_disallowed_usernames:
  - "{{ users_basedir | regex_replace('^\\/') }}"
  - "{{ users_apache_chroot_mount_dirs }}"
# Users home directories to be created as sub-directories of users_basedir
# NOTE that you can set an individual users_home to override this, for example
# for www-data set users_home: /var/www and for root set users_home: /root
users_basedir: /home
users_sites_dir: sites
users_sites_dir_mode: "0750"
# Define users_matomo to true for servers with Matomo and automatic Matomo account
# provisioning for users which have users_matomo_account set to True
users_matomo: false
# Define users_mariadb to true for this role to create MariaDB user and
# databases
users_mariadb: false
# The following script is available here https://git.coop/webarch/scripts/-/blob/master/bin/mysql-backup-user
users_backup_script: /usr/local/bin/mysql-backup-user
# MySQL user privileges copied from
# https://www.a2hosting.com/kb/developer-corner/mysql/mysql-user-privileges-on-shared-servers
users_mariadb_database_privileges:
  - ALTER
  - ALTER ROUTINE
  - CREATE
  - CREATE ROUTINE
  - CREATE TEMPORARY TABLES
  - CREATE VIEW
  - DELETE
  - DROP
  - EXECUTE
  - INDEX
  - INSERT
  - LOCK TABLES
  - REFERENCES
  - SELECT
  - SHOW VIEW
  - TRIGGER
  - UPDATE
# Define users_phpfpm to true for this role to generate PHP FPM pools
users_phpfpm: false
# Define users_cron to true for this role to generate cron tasks
users_cron: false
# Set users_quotaon to true for this role to manage users disk quotas, this needs
# the users_basedir variable to be a partition mounted with quota options
users_quotaon: false
users_state_dir: /root/users
# users_private_files, the owner and group defaults to the user and the users
# group unless specified.
users_private_files:
  - path: .ansible
    mode: "0700"
    state: directory
  - path: .bash_aliases
    mode: "0600"
    state: touch
  - path: .bash_history
    mode: "0600"
    state: touch
  - path: .bash_logout
    mode: "0600"
    state: touch
  - path: .bash_profile
    mode: "0600"
    state: touch
  - path: .bashrc
    mode: "0600"
    state: touch
  - path: bin
    mode: "0700"
    state: directory
  - path: .cache
    mode: "0700"
    state: directory
  - path: .composer
    mode: "0700"
    state: directory
  - path: .console
    mode: "0700"
    state: directory
  - path: .config
    mode: "0700"
    state: directory
  - path: .drush
    mode: "0700"
    state: directory
  - path: .git
    mode: "0700"
    state: directory
  - path: .gnupg
    mode: "0700"
    state: directory
  - path: .local
    mode: "0700"
    state: directory
  - path: .mycli-audit.log
    mode: "0600"
    state: touch
  - path: .mycli-history
    mode: "0600"
    state: touch
  - path: .mycli.log
    mode: "0600"
    state: touch
  - path: .myclirc
    mode: "0400"
    state: touch
  - path: .mysql
    mode: "0700"
    state: directory
  - path: .mysql/history
    mode: "0600"
    state: touch
  - path: .mutt
    mode: "0700"
    state: directory
  - path: .nanorc
    mode: "0600"
    state: touch
  - path: .npm
    mode: "0700"
    state: directory
  - path: private
    mode: "0700"
    state: directory
  - path: .profile
    mode: "0600"
    state: touch
  - path: .selected_editor
    mode: "0600"
    state: touch
  - path: .ssh
    mode: "0700"
    state: directory
  - path: tmp
    mode: "0700"
    state: directory
  - path: .terminfo
    mode: "0700"
    state: directory
  - path: .vim
    mode: "0700"
    state: directory
  - path: .vimrc
    mode: "0600"
    state: touch
  - path: .wp-cli
    mode: "0700"
    state: directory
  - path: .wp-cli/config.yml
    mode: "0600"
    state: touch
  - path: .yarn
    mode: "0700"
    state: directory
  - path: .yarnrc
    mode: "0600"
    state: touch
users_notify_from: "Webarchitects <root@{{ inventory_hostname }}>"
users_notify_reply_to: "Webarchitects <support@webarchitects.coop>"
users_notify_headers:
  - Reply-To = {{ users_notify_reply_to }}
  - X-Auto-Response-Suppress = All
users_notify_subject_tag: webarchitects
users_notify_signature: |
  Webarch Co-operative Limited
  https://www.webarchitects.coop/
  Contact: https://webarch.net/contact
  Help:    https://docs.webarch.net/
  Status:  https://webarch.info/
users_notify_cron_append: "Reply-To: {{ users_notify_reply_to }}"
users_forward: true
users_muttrc: true
users_cert: user
# For Nextcloud updates users_apache_php_proxy_timeout needs to be set to 1200,
# this is best done at a VirtualHost level
users_apache_php_proxy_timeout: 300
#
# Define one or more of the the three following arrays if you want to overide
# the users_apache_type of php, cgi or the default of static that are set in
# the apache.conf.j2 template:
# users_apache_options:
#   - -Indexes
#   - +SymlinksIfOwnerMatch
#   - -MultiViews
#   - +IncludesNOEXEC
#   - -ExecCGI
# users_apache_index:
#   - index.php
#   - index.html
#   - index.shtml
#   - index.htm
# users_apache_override:
#   - AuthConfig
#   - FileInfo
#   - Indexes
#   - Limit
#   - Options=Indexes,SymLinksIfOwnerMatch,MultiViews,IncludesNOEXEC
#   - Nonfatal=Override
#
# The users_cgi_extensions array is for a list of files extensions to be
# processed as CGI, it can also be set at a users level
users_cgi_extensions:
  - cgi
  - pl
# https://www.php.net/manual/en/install.fpm.configuration.php
users_phpfpm_pm: dynamic
users_phpfpm_pm_max_children: 3
users_phpfpm_pm_start_servers: 2
users_phpfpm_pm_min_spare_servers: 1
users_phpfpm_pm_max_spare_servers: 1
users_phpfpm_request_terminate_timeout: 360
# The users_phpfpm_extensions array is for a list of files extensions to be
# processed for PHP commands, it can also be set at a users level
users_phpfpm_extensions:
  - php
users_phpfpm_enable_open_basedir: false
# PHP expands $pool to the pool name and in this case it is the same as the username
users_phpfpm_open_basedir:
  - "{% if users_apache_chroot is defined and users_apache_chroot %}{{ users_apache_chroot_users_basedir }}{% else %}{{ users_basedir }}{% endif %}/$pool/{{ users_sites_dir }}/"
  - "{% if users_apache_chroot is defined and users_apache_chroot %}{{ users_apache_chroot_users_basedir }}{% else %}{{ users_basedir }}{% endif %}/$pool/tmp/"
  - /usr/share/php
# The MediaWiki file includes/shell/Command.php uses/bin/bash
users_phpfpm_open_basedir_mediawiki:
  - "{% if users_apache_chroot is defined and users_apache_chroot %}{{ users_apache_chroot_users_basedir }}{% else %}{{ users_basedir }}{% endif %}/$pool/{{ users_sites_dir }}/"
  - "{% if users_apache_chroot is defined and users_apache_chroot %}{{ users_apache_chroot_users_basedir }}{% else %}{{ users_basedir }}{% endif %}/$pool/tmp/"
  - /usr/share/php
  - /bin
# users_phpfpm_disable_functions values are appended, they do not overwrite
# previously defined php.ini values, set to [] to disable
users_phpfpm_disable_functions:
  - chgrp
  - chown
  # curl_exec is used by Nextcloud, some MediaWiki extensions and the
  # WordPress Piwik plugin
  # - curl_exec
  # curl_multi_exec is used by the MediaWiki VisualEditor and some
  # WordPress plugins
  # - curl_multi_exec
  - dl
  # exec is used by the Nexcloud ONLYOFFICE app
  - exec
  # fsockopen is used by CiviCRM to send email
  - fsockopen
  - passthru
  - pcntl_alarm
  - pcntl_fork
  - pcntl_waitpid
  - pcntl_wait
  - pcntl_wifexited
  - pcntl_wifstopped
  - pcntl_wifsignaled
  - pcntl_wifcontinued
  - pcntl_wexitstatus
  - pcntl_wtermsig
  - pcntl_wstopsig
  - pcntl_signal
  - pcntl_signal_get_handler
  - pcntl_signal_dispatch
  - pcntl_get_last_error
  - pcntl_strerror
  - pcntl_sigprocmask
  - pcntl_sigwaitinfo
  - pcntl_sigtimedwait
  - pcntl_exec
  - pcntl_getpriority
  - pcntl_setpriority
  - pcntl_async_signals
  - pcntl_unshare
  - popen
  - posix_kill
  - posix_mkfifo
  - posix_setpgid
  - posix_setsid
  - posix_setuid
  # The proc_ functions are used by some features of MediaWiki
  - proc_close
  - proc_get_status
  - proc_nice
  - proc_open
  - proc_terminate
  # The shell_exec function is used by Matomo
  - shell_exec
  - show_source
  - socket_create
  - symlink
  - system
  - system_exec
users_phpfpm_disable_functions_civicrm:
  - chgrp
  - chown
  # curl_exec is used by Nextcloud, some MediaWiki extensions and the
  # WordPress Piwik plugin
  # - curl_exec
  # curl_multi_exec is used by the MediaWiki VisualEditor
  - curl_multi_exec
  - dl
  # exec is used by the Nexcloud ONLYOFFICE app
  - exec
  # fsockopen is used by CiviCRM to send email
  # - fsockopen
  - passthru
  - pcntl_alarm
  - pcntl_fork
  - pcntl_waitpid
  - pcntl_wait
  - pcntl_wifexited
  - pcntl_wifstopped
  - pcntl_wifsignaled
  - pcntl_wifcontinued
  - pcntl_wexitstatus
  - pcntl_wtermsig
  - pcntl_wstopsig
  - pcntl_signal
  - pcntl_signal_get_handler
  - pcntl_signal_dispatch
  - pcntl_get_last_error
  - pcntl_strerror
  - pcntl_sigprocmask
  - pcntl_sigwaitinfo
  - pcntl_sigtimedwait
  - pcntl_exec
  - pcntl_getpriority
  - pcntl_setpriority
  - pcntl_async_signals
  - pcntl_unshare
  - popen
  - posix_kill
  - posix_mkfifo
  - posix_setpgid
  - posix_setsid
  - posix_setuid
  # The proc_ functions are used by some features of MediaWiki
  - proc_close
  - proc_get_status
  - proc_nice
  - proc_open
  - proc_terminate
  # The shell_exec function is used by Matomo
  - shell_exec
  - show_source
  - socket_create
  - symlink
  - system
  - system_exec
users_phpfpm_disable_functions_matomo:
  - chgrp
  - chown
  # curl_exec is used by Nextcloud, some MediaWiki extensions and the
  # WordPress Piwik plugin
  # - curl_exec
  # curl_multi_exec is used by the MediaWiki VisualEditor
  - curl_multi_exec
  - dl
  - exec
  # fsockopen is used by CiviCRM to send email
  - fsockopen
  - passthru
  - pcntl_alarm
  - pcntl_fork
  - pcntl_waitpid
  - pcntl_wait
  - pcntl_wifexited
  - pcntl_wifstopped
  - pcntl_wifsignaled
  - pcntl_wifcontinued
  - pcntl_wexitstatus
  - pcntl_wtermsig
  - pcntl_wstopsig
  - pcntl_signal
  - pcntl_signal_get_handler
  - pcntl_signal_dispatch
  - pcntl_get_last_error
  - pcntl_strerror
  - pcntl_sigprocmask
  - pcntl_sigwaitinfo
  - pcntl_sigtimedwait
  - pcntl_exec
  - pcntl_getpriority
  - pcntl_setpriority
  - pcntl_async_signals
  - pcntl_unshare
  - popen
  - posix_kill
  - posix_mkfifo
  - posix_setpgid
  - posix_setsid
  - posix_setuid
  # The proc_ functions are used by some features of MediaWiki
  - proc_close
  - proc_get_status
  - proc_nice
  - proc_open
  - proc_terminate
  # The shell_exec function is used by Matomo
  # - shell_exec
  - show_source
  - socket_create
  - symlink
  - system
  - system_exec
users_phpfpm_disable_functions_mediawiki:
  - chgrp
  - chown
  # curl_exec is used by Nextcloud, some MediaWiki extensions and the
  # WordPress Piwik plugin
  # - curl_exec
  # curl_multi_exec is used by the MediaWiki VisualEditor
  # - curl_multi_exec
  - dl
  - exec
  # fsockopen is used by CiviCRM to send email
  - fsockopen
  - passthru
  - pcntl_alarm
  - pcntl_fork
  - pcntl_waitpid
  - pcntl_wait
  - pcntl_wifexited
  - pcntl_wifstopped
  - pcntl_wifsignaled
  - pcntl_wifcontinued
  - pcntl_wexitstatus
  - pcntl_wtermsig
  - pcntl_wstopsig
  - pcntl_signal
  - pcntl_signal_get_handler
  - pcntl_signal_dispatch
  - pcntl_get_last_error
  - pcntl_strerror
  - pcntl_sigprocmask
  - pcntl_sigwaitinfo
  - pcntl_sigtimedwait
  - pcntl_exec
  - pcntl_getpriority
  - pcntl_setpriority
  - pcntl_async_signals
  - pcntl_unshare
  - popen
  - posix_kill
  - posix_mkfifo
  - posix_setpgid
  - posix_setsid
  - posix_setuid
  # The proc_ functions are used by some features of MediaWiki
  # - proc_close
  # - proc_get_status
  # - proc_nice
  # - proc_open
  # - proc_terminate
  # The shell_exec function is used by Matomo
  - shell_exec
  - show_source
  - socket_create
  - symlink
  - system
  - system_exec
users_phpfpm_disable_functions_nextcloud:
  - chgrp
  - chown
  # curl_exec is used by Nextcloud and some MediaWiki extensions
  # - curl_exec
  # curl_multi_exec is used by the MediaWiki VisualEditor
  - curl_multi_exec
  - dl
  - exec
  # fsockopen is used by CiviCRM to send email
  - fsockopen
  - passthru
  - pcntl_alarm
  - pcntl_fork
  - pcntl_waitpid
  - pcntl_wait
  - pcntl_wifexited
  - pcntl_wifstopped
  - pcntl_wifsignaled
  - pcntl_wifcontinued
  - pcntl_wexitstatus
  - pcntl_wtermsig
  - pcntl_wstopsig
  - pcntl_signal
  - pcntl_signal_get_handler
  - pcntl_signal_dispatch
  - pcntl_get_last_error
  - pcntl_strerror
  - pcntl_sigprocmask
  - pcntl_sigwaitinfo
  - pcntl_sigtimedwait
  - pcntl_exec
  - pcntl_getpriority
  - pcntl_setpriority
  - pcntl_async_signals
  - pcntl_unshare
  - popen
  - posix_kill
  - posix_mkfifo
  - posix_setpgid
  - posix_setsid
  - posix_setuid
  # The proc_ functions are used by some features of MediaWiki
  - proc_close
  - proc_get_status
  - proc_nice
  - proc_open
  - proc_terminate
  # The shell_exec function is used by Matomo
  - shell_exec
  - show_source
  - socket_create
  - symlink
  - system
  - system_exec
users_cron_daily_hour: "05"
users_cron_mysqldump_hour: "00"
# Set users_cron_tmpdir_hour to false to disable deletion of users TMPDIR
# files and directories which are older than a week for the whole server
users_cron_tmpdir_hour: "00"
# How old are TMPDIR files allowed to be before they are deleted
users_cron_tmpdir_max_age_days: 2
# Matomo user accounts will only be deleted when user accounts are deleted if
# users_matomo_delete_users is set to true
users_matomo_delete_users: false
users_ssh_authorized_keys_file_name: authorized_keys
# On Bullseye Bash is /bin/bash, on Xenial it is also in /usr/bin/bash, on
# Bookworm it will be in /usr/bin/bash, this role will set users_bash to the
# last option in /etc/shells ending in /bash, so set it manually if this isn't
# what is wanted
# users_bash: /usr/bin/bash
...
